Subject: RE: [Sip] Escaping rules of SIP-URI userpart

From: "Christer Holmberg \(JO/LMF\)" <[email-masked]>
Date: Mon, 2 Oct 2006 11:58:48 +0200

Hi, 

>What I have seen in many implementations is that the # is 
>part of the SIP URI userpart, when there is a B2BUA that has 
>to activate or deactivate a service like the ones mentioned 
>in the thread.

It could be a B2BUA, or an application server.

>The question would be if this is a valid usage on such implementations

Well, that was not my original question :) Because, I have not seen anywhere any rule that would forbid this.

My question was whether it would be possible to use "#" unescapted in a SIP-URI, since it would e.g speed up parsing, and mapping from TEL-URI (where # IS allowed unescaped) to SIP-URI without having to first search the the TEL-URI for a # character and escape it.

Regards,

Christer

> -----Original Message-----
> From: Francois Audet [mailto:[email-masked]]
> Sent: Friday, September 29, 2006 1:47 PM
> To: Christer Holmberg (JO/LMF); Jesske, R; 
> [email-masked]; [email-masked]
> Subject: RE: [Sip] Escaping rules of SIP-URI userpart
> 
> 
> 
> > -----Original Message-----
> > From: Christer Holmberg (JO/LMF)
> > [mailto:[email-masked]]
> > Sent: Friday, September 29, 2006 3:55 AM
> > To: Jesske, R; [email-masked]; [email-masked]
> > Subject: RE: [Sip] Escaping rules of SIP-URI userpart
> > 
> > 
> > Hi Roland,
> > 
> > >I really confused about this discussion regarding'#'.
> > >The range of a telephone number Digit is 0,1,2...9,A,B,C,D,F
> > as far as
> > >I know (it's a binary 4 Digit code ).
> > >You can look in Q.764 which of the digits are used for 
> what and also
> > >E.164 gives a guideline.
> > > 
> > >So for what Telephone application '#' is used?
> > 
> > You can use if for service codes. *21#3455
> > 
> > ...or something like that.
> 
> There is no need for this in a URI. The service code should 
> be translatable by the phone to a real URI that actually 
> means something.
>  
> > ...or "Please enter your pin code, followed by #".
> 
> That's not a phone number: it's dialled digits, and it is 
> coverered by KPML and RFC 2833. It has no place in a URI.
> 
> > Regards,
> > 
> > Christer
> > 
> > 
> > 
> > 
> > 
> > > > -----Ursprüngliche Nachricht-----
> > > > Von: Christer Holmberg (JO/LMF)
> > > > [mailto:[email-masked]]
> > > > Gesendet: Donnerstag, 28. September 2006 21:17
> > > > An: [email-masked]; [email-masked]
> > > > Betreff: RE: [Sip] Escaping rules of SIP-URI userpart
> > > > 
> > > > 
> > > >  
> > > > Also, I don't think that the RFC 3261 ABNF even allows for
> > > the usage
> > > > of "#" as a delimiter, as defned in RFC2396.
> > > > 
> > > > Chapter 4 of RFC2396 says:
> > > > 
> > > > URI-reference = [ absoluteURI | relativeURI ] [ "#" fragment ]
> > > > 
> > > > First, we can see that the fragment part cannot be within
> > > the URI, it
> > > > optionally follows the URI
> > > > 
> > > > Second, we can see that the fragment is not part of the
> > URI, it is
> > > > part of URI-reference.
> > > > 
> > > > Third, there is no mentioning of URI-reference in the SIP ABNF.
> > > > 
> > > > 
> > > > For example, the Request-URI is defined as: 
> > > > 
> > > > Request-URI =  SIP-URI / SIPS-URI / absoluteURI
> > > > 
> > > > But, nowhere is ["#" fragment] mentioned. 
> > > > 
> > > > So, I doubt that many parsers implemented based on the SIP
> > > ABNF would
> > > > even accept a URI followed by a fragment in a SIP message.
> > > > 
> > > > Regards,
> > > > 
> > > > Christer
> > > > 
> > > > 
> > > > 
> > > > 
> > > > 
> > > > 
> > > > 
> > > > 
> > > > > -----Original Message-----
> > > > > From: Christer Holmberg (JO/LMF) 
> > > > > [mailto:[email-masked]]
> > > > > Sent: 28. syyskuuta 2006 19:03
> > > > > To: [email-masked]; [email-masked]
> > > > > Subject: VS: [Sip] Escaping rules of SIP-URI userpart
> > > > > 
> > > > > Hi Dale,
> > > > > 
> > > > > 
> > > > > >   The issue is that I don't understand why that rule is
> > > > > needed. User=phone
> > > > > >   means that the userpart shall be parsed as a
> > > > > telephone-subscriber, and
> > > > > >   within a telephone-subscriber the "#" does not have any
> > > > > special meaning,
> > > > > >   so there is no need to escape it.
> > > > > >
> > > > > >   So, yes, you probably have to go with:
> > > > > >
> > > > > >   sip:[email-masked]
> > > > > >
> > > > > >  But, I see no reason why you should have to go with:
> > > > > >
> > > > > >   sip:[email-masked];user=phone
> > > > > >
> > > > > >   Instead you could use:
> > > > > >
> > > > > >   sip:[email-masked];user=phone
> > > > > >
> > > > > How would you write a left-to-right parser that could cope
> > > > with that?
> > > > > 
> > > > > [CHH] Well, you can't really perform a detailed parse of the 
> > > > > userpart before you have parsed the user parameter anyway.
> > > > >  
> > > > > And, whatever the value of the user parameter is, I have
> > > never seen
> > > > > "#" used as this kind of delmiter in a SIP-URI anyway...
> > > > >  
> > > > > Regards,
> > > > >  
> > > > > Christer
> > > > > 
> > > > >  
> > > > > 
> > > > >  
> > > > > 
> > > > >  
> > > > > 
> > > > >  
> > > > > 
> > > > >  
> > > > > 
> > > > > 
> > > > > Dale
> > > > > 
> > > > > _______________________________________________
> > > > > Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
> > > > > This list is for NEW development of the core SIP Protocol Use 
> > > > > [email-masked] for questions on
> > current sip Use
> > > > > [email-masked] for new developments on the 
> application of sip
> > > > > 
> > > > > 
> > > > > _______________________________________________
> > > > > Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
> > > > > This list is for NEW development of the core SIP Protocol Use 
> > > > > [email-masked] for questions on
> > current sip Use
> > > > > [email-masked] for new developments on the 
> application of sip
> > > > > 
> > > > 
> > > > _______________________________________________
> > > > Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
> > > > This list is for NEW development of the core SIP Protocol Use 
> > > > [email-masked] for questions on 
> current sip Use 
> > > > [email-masked] for new developments on the application of sip
> > > > 
> > > 
> > 
> > _______________________________________________
> > Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
> > This list is for NEW development of the core SIP Protocol Use 
> > [email-masked] for questions on current sip Use 
> > [email-masked] for new developments on the application of sip
> > 
> 
> _______________________________________________
> Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
> This list is for NEW development of the core SIP Protocol Use 
> [email-masked] for questions on current sip 
> Use [email-masked] for new developments on the application of sip
> 

_______________________________________________
Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip

---

From: "Jeroen van Bemmel" <[email-masked]>
Date: Tue, 3 Oct 2006 00:38:48 +0200

----- Original Message ----- 
From: "Christer Holmberg (JO/LMF)" <[email-masked]>
To: "Hector Morales (hemorale)" <[email-masked]>; "Francois Audet" 
<[email-masked]>; "Jesske, R" <[email-masked]>; 
<[email-masked]>; <[email-masked]>
Sent: Monday, October 02, 2006 11:58 AM
Subject: RE: [Sip] Escaping rules of SIP-URI userpart

Hi,

>The question would be if this is a valid usage on such implementations

Well, that was not my original question :) Because, I have not seen anywhere 
any rule that would forbid this.

My question was whether it would be possible to use "#" unescapted in a 
SIP-URI, since it would e.g speed up parsing, and mapping from TEL-URI 
(where # IS allowed unescaped) to SIP-URI without having to first search the 
the TEL-URI for a # character and escape it.

Regards,

Christer